(function($) {
	//全局配置(通常所有页面引用该配置，特殊页面使用mui.init({})来覆盖全局配置)
	$.initGlobal({
		gestureConfig: {
			tap: true, //默认为true
			doubletap: true, //默认为false
			longtap: true, //默认为false
			swipe: true, //默认为true
			drag: true, //默认为true
			hold: false, //默认为false，不监听
			release: false //默认为false，不监听
		},
		swipeBack: true
	});
	var back = $.back;
	$.back = function() {

		var current = plus.webview.currentWebview();
		if (current.mType === 'main') { //模板主页面

			//关闭搜索
			current.evalJS('hideSearch()');
			current.hide('auto');
			setTimeout(function() {
				document.getElementById("title").className = 'mui-title mui-fadeout';
				current.children()[0].hide("none");
				//关闭批量操作 HY
				current.children()[0].evalJS("if(typeof wSelect !='undefined')wSelect.disableChecked()");

			}, 200);
		} else if (current.mType === 'sub') {
			//关闭批量操作 HY
			if (typeof wSelect != 'undefined')
				wSelect.disableChecked();
			if ($.targets._popover) {
				$($.targets._popover).popover('hide');
			} else {
				current.parent().evalJS('mui&&mui.back();');
			}
		} else {
			back();
		}
	}
})(mui);

/**
 * toggle
 */
window.addEventListener('toggle', function(event) {
	if (event.target.id === 'M_Toggle') {
		var isActive = event.detail.isActive;
		var table = document.querySelector('.mui-table-view');
		var card = document.querySelector('.mui-card');
		if (isActive) {
			card.appendChild(table);
			card.style.display = '';
		} else {
			var content = document.querySelector('.mui-content');
			content.insertBefore(table, card);
			card.style.display = 'none';
		}
	}
});


var templates = {};

var getTemplate = function(name, header, content, loading) {
	var template = templates[name];
	if (!template) {
		//预加载共用父模板；
		var headerWebview = mui.preload({
			url: header,
			id: name + "-main",
			styles: {
				popGesture: "hide"
			},
			extras: {
				mType: 'main'
			}
		});
		//预加载共用子webview
		var subWebview = mui.preload({
			url: !content ? "" : content,
			id: name + "-sub",
			styles: {
				top: '60px',
				bottom: '0px'
			},
			extras: {
				mType: 'sub'
			}
		});
		subWebview.addEventListener('loaded', function() {
			setTimeout(function() {
				subWebview.show();
			}, 50);
		});
		subWebview.hide();
		headerWebview.append(subWebview);
		//iOS平台支持侧滑关闭，父窗体侧滑隐藏后，同时需要隐藏子窗体；
		if (mui.os.ios) { //5+父窗体隐藏，子窗体还可以看到？不符合逻辑吧？
			headerWebview.addEventListener('hide', function() {
				subWebview.hide("none");
			});
		}
		templates[name] = template = {
			name: name,
			header: headerWebview,
			content: subWebview,
			loaded: loading
		};
	}
	return template;
};

//初始化，并预加载webview模式的选项卡，
//注意不要在目标页面的mui.ready事件里面写 mui.currentWebview.show() 语句
function preload() {

	mui.preload({
		url: "pages/info.html",
		styles: {
			popGesture: 'hide'
		}
	});
}

//主列表点击事件
function setNavHref(a) {
	var id = a.getAttribute('href');
	var type = a.getAttribute("open-type");
	var btn = a.getAttribute("header-button");
	if (btn == null) {
		btn = 'add';
	}
	if (type == "common") {
		if (~id.indexOf('offcanvas-')) {
			var pop = ~id.indexOf('offcanvas-with-right') ? "close" : "none";
			mui.openWindow({
				id: id,
				url: a.href,
				styles: {
					zindex: 9998,
					popGesture: pop
				},
				show: {
					autoShow: true,
					aniShow: animation,
					duration: durations
				},
				waiting: {
					autoShow: false
				}
			});
		} else {

			mui.openWindow({
				id: id,
				url: a.href,
				show: {
					autoShow: true,
					aniShow: animation,
					duration: durations
				},
				waiting: {
					autoShow: false
				}
			});
		}
	} else {
		if (id && ~id.indexOf('.html')) {
			var href = a.href;
			//获得共用模板组
			var template = getTemplate('default');

			//判断是否显示右上角 +添加  或 √保存 按钮；
			var visible = href.indexOf('rooms.html') > -1 && hasTask(taskCode_RoomCreate) || href.indexOf('receipts.html') > -1 && hasTask(taskCode_ReceiptCreate) || href.indexOf('customers.html') > -1 && hasTask(taskCode_CustomerCreate) || href.indexOf('notices.html') > -1 && hasTask(taskCode_NoticeCreate) || href.indexOf('waters.html') > -1 && hasTask(taskCode_ReceiptCreate);

			btn = visible ? btn : 'none';

			var showSearch = href.indexOf('finances.html') == -1 && href.indexOf('waters.html') == -1;
			//获得共用父模板
			var headerWebview = template.header;
			//获得共用子webview
			var contentWebview = template.content;
			var title = a.querySelector('.mui-media-body').innerText;
			//通知模板修改标题，并显示隐藏右上角图标；
			mui.fire(headerWebview, 'updateHeader', {
				title: title,
				showSearch: showSearch,
				headerButton: btn
			});

			var reload = true;
			if (!template.loaded) {
				if (contentWebview.getURL() != a.href) {
					//mui.toast('1')
					contentWebview.loadURL(a.href);
				} else {
					//mui.toast('2')
					reload = false;
				}
			} else {
				reload = false;
			}
			(!reload) && contentWebview.show();
			headerWebview.show(animation, durations);
		}
	}
}


/**非框架代码 BEGIN*/

var server = 'wyzf.com.cn';
var address_all = '请选择地址';
var msgBoxTitle = '租房管理',
	buttonCapture = '我知道了',
	confirmButtons = ["是", "否"],
	error_timeout = '哎哟，网络不给力呀',
	loading = '正在玩命加载',
	noroom = '请在 “房源” 中添加房间后，再进行抄表',
	access_denied = '抱歉，您没有此操作权限';


var settings_model = 'wyzf.settings.model',
	user_model = 'wyzf.user.model',
	user_TimeCreated = 'wyzf.user.TimeCreated',
	room_Addresses = 'wyzf.room.addresses';

var pf_down_contentdown = "下拉刷新",
	pf_down_contentover = "释放立即刷新",
	pf_down_contentrefresh = "客官请稍等,正在刷新...",
	pf_up_contentrefresh = "正在刷新...",
	pf_up_contentnomore = "没有更多数据了";

var timeout = 10 * 1000;
var timeouted = false;
var interval = 1500; //加载时间间隔
var autoSearch = 10; //监听搜索框变化时间间隔
var durations = 200;
var rowBackgroundColor = '#F8F9FB'; //列表行背景色
var animation = 'zoom-fade-out';

var taskCode_RoomCreate = "Room_Create",
	taskCode_RoomDelete = "Room_Delete",
	taskCode_RoomUpdate = "Room_Update",
	taskCode_RoomView = "Room_View",
	taskCode_ReceiptCreate = "Receipt_Create",
	taskCode_ReceiptDelete = "Receipt_Delete",
	taskCode_ReceiptUpdate = "Receipt_Update",
	taskCode_ReceiptView = "Receipt_View",
	taskCode_ContractCreate = "Contract_Create",
	taskCode_ContractDelete = "Contract_Delete",
	taskCode_ContractUpdate = "Contract_Update",
	taskCode_ContractView = "Contract_View",
	taskCode_CustomerCreate = "Customer_Create",
	taskCode_CustomerDelete = "Customer_Delete",
	taskCode_CustomerUpdate = "Customer_Update",
	taskCode_CustomerView = "Customer_View",
	taskCode_CustomerCreate = "Customer_Create",
	taskCode_CustomerDelete = "Customer_Delete",
	taskCode_CustomerUpdate = "Customer_Update",
	taskCode_CustomerView = "Customer_View",
	taskCode_NoticeCreate = "Notice_Create",
	taskCode_NoticeDelete = "Notice_Delete",
	taskCode_NoticeUpdate = "Notice_Update",
	taskCode_NoticeView = "Notice_View",
	taskCode_SettingsCreate = "Settings_Create",
	taskCode_SettingsDelete = "Settings_Delete",
	taskCode_SettingsUpdate = "Settings_Update",
	taskCode_SettingsView = "Settings_View",
	taskCode_ReportView = "Report_View",
	taskCode_SettleCreate = "Settle_Create",
	taskCode_SendMessage = "Send_Message",
	taskCode_Manager = 'Manager';

var settings = getJSONCache(settings_model);

/**
 * 表单数据序列化
 */
function serialize(form) {
	var str = "";
	var elements = form;
	if (form == null) {
		return str;
	}

	for (var i = 0; i < elements.length; i++) {

		var name = elements[i].name;
		if (name != '') {
			str += elements[i].name + '=' + elements[i].value + '&';
		}
	}
	if (str != '')
		str = str.substr(0, str.length - 1);

	return (encodeURI(str));
}

/**
 * @description{表单数据JSON序列化}
 */
function jsonlizeForm(form, data) {

	if (data) {
		for (var i = 0; i < form.length; i++) {
			var item = form[i];
			if (item.name != '') {
				try {
					eval('data.' + item.name + '="' + item.value + '"');
				} catch (e) {
					continue;
				}
			}
		}
		return data;
	} else {
		var str = '{';
		for (var i = 0; i < form.length; i++) {

			var item = form[i];
			if (item.name != '') {
				str += '"' + item.name + '":"' + item.value + '",';
			}
		}
		if (str != '')
			str = str.substr(0, str.length - 1);
		str += '}';
		return JSON.parse(str);
	}
}


function setFormValue(form, model) {

	if (form == null || model == undefined)
		return;
	for (var i = 0; i < form.length; i++) {
		var name = form[i].name;
		if (name != '') {
			var value = eval('model.' + name);
			if (value != undefined) {
				form[i].value = formatValue(value);
			}
		}
	}
}

function formatValue(value) {
	if ((typeof value) == 'boolean') {
		value = value.toString();
	} else if ((typeof value) == 'number' && value == 0) {
		value = '0';
	} else if (value == '001-01-01') {
		value = '';
	}
	return value;
}

function fixedAmount(amount) {

	var amountDecimals = parseInt(settings.AmountDecimals);

	return parseFloat(amount).toFixed(amountDecimals);
}

/**
 * 表单数据JSON化
 */
function jsonlize(form) {
	var str = "";
	var elements = form;
	if (form == null) {
		return str;
	}

	str = '{'

	for (var i = 0; i < elements.length; i++) {

		var name = elements[i].name;
		if (name != '') {
			str += elements[i].name + ":'" + elements[i].value + "',";
		}
	}

	if (str != '{')
		str = str.substr(0, str.length - 1);
	str += '}';
	var obj = eval('(' + str + ')');
	return obj;
}

/**
 * 验证表单输入
 */
function validateInput(form) {

	var elements = form;
	for (var i = 0; i < elements.length; i++) {

		var value = elements[i].value;
		var required = elements[i].getAttribute('required');
		var tips = elements[i].getAttribute('validateTips');
		var placeholder = elements[i].getAttribute('placeholder');
		var equalTo = elements[i].getAttribute('equalTo');
		var max = elements[i].getAttribute('max');
		var min = elements[i].getAttribute('min');
		var msg = tips || placeholder;

		if (required == 'required' && value == '') {
			if (tips)
				mui.toast(tips);
			else
				mui.toast(placeholder);
			elements[i].focus();

			return false;
		}

		if (equalTo != null) {
			var v1 = form.querySelector('input[name=' + equalTo + ']').value;
			if (v1 != value) {
				mui.toast('两次输入不一致');
				elements[i].focus();

				return false;
			}
		}

		if (max && !isNaN(max) && parseFloat(value) != 0 && parseFloat(value) > parseFloat(max)) {

			mui.toast(msg + '不能大于' + max);
			elements[i].focus();
			return false;
		}
		if (min && !isNaN(min) && parseFloat(value) != 0 && parseFloat(value) < parseFloat(min)) {

			mui.toast(msg + '不能小于' + min);
			elements[i].focus();
			return false;
		}
	}
	var phones = form.querySelectorAll('.phone');
	for (var i = 0; i < phones.length; i++) {

		var valid = validatePhone(phones[i])
		if (!valid) {
			phones[i].focus();
			return false;
		}

	}

	return true;
}

function validatePhone(phone) {

	if (phone.value == '') {
		return true;
	}

	//var phone = document.querySelector('.phone');
	var isPhone = (phone.value.length == 11 && /^(((13[0-9]{1})|(14[0-9]{1})|(15[0-9]{1})|(17[0-9]{1})|(18[0-9]{1}))+\d{8})$/.test(phone.value));
	if (!isPhone) {
		mui.toast('请输入正确的手机号码');
		phone.focus();
		phone.select();
		return false;
	}
	return true;
}

/**
 * 验证是否为JSON数据
 */

function validateJSON(obj) {
	var isjson = typeof(obj) == "object" && Object.prototype.toString.call(obj).toLowerCase() == "[object object]" && !obj.length;
	return isjson;
}
/*
 * 验证用户登录状态
 */

function validateUser(obj) {
	if (obj != null && typeof obj.IsSucced == 'boolean') {
		if (!obj.IsSucced) {
			mui.toast('连接超时，请重新登录');
			openWindow('login', '../login.html', null, null);
		}
	}
}

function refreshList() {

	//获得列表界面的webview
	//var list = plus.webview.getWebviewById('default-sub');
	var list = plus.webview.currentWebview().opener();
	//触发列表界面的自定义事件（refresh）,从而进行数据刷新
	mui.fire(list, 'refreshList');
	//返回true，继续页面关闭逻辑
	return true;
}

var formatDate = function(dateStr) {

	return dateStr.split(' ')[0];
}

/*
 * Date Format 1.2.3
 * (c) 2007-2009 Steven Levithan <stevenlevithan.com>
 * MIT license
 *
 * Includes enhancements by Scott Trenda <scott.trenda.net>
 * and Kris Kowal <cixar.com/~kris.kowal/>
 *
 * Accepts a date, a mask, or a date and a mask.
 * Returns a formatted version of the given date.
 * The date defaults to the current date/time.
 * The mask defaults to dateFormat.masks.default.
 */


var dateFormat = function() {
	var token = /d{1,4}|m{1,4}|yy(?:yy)?|([HhMsTt])\1?|[LloSZ]|"[^"]*"|'[^']*'/g,
		timezone = /\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,
		timezoneClip = /[^-+\dA-Z]/g,
		pad = function(val, len) {
			val = String(val);
			len = len || 2;
			while (val.length < len) val = "0" + val;
			return val;
		};

	// Regexes and supporting functions are cached through closure
	return function(date, mask, utc) {
		var dF = dateFormat;

		// You can't provide utc if you skip other args (use the "UTC:" mask prefix)
		if (arguments.length == 1 && Object.prototype.toString.call(date) == "[object String]" && !/\d/.test(date)) {
			mask = date;
			date = undefined;
		}

		// Passing date through Date applies Date.parse, if necessary
		date = date ? new Date(date) : new Date;
		if (isNaN(date)) return ''; //throw SyntaxError("invalid date");

		mask = String(dF.masks[mask] || mask || dF.masks["default"]);

		// Allow setting the utc argument via the mask
		if (mask.slice(0, 4) == "UTC:") {
			mask = mask.slice(4);
			utc = true;
		}

		var _ = utc ? "getUTC" : "get",
			d = date[_ + "Date"](),
			D = date[_ + "Day"](),
			m = date[_ + "Month"](),
			y = date[_ + "FullYear"](),
			H = date[_ + "Hours"](),
			M = date[_ + "Minutes"](),
			s = date[_ + "Seconds"](),
			L = date[_ + "Milliseconds"](),
			o = utc ? 0 : date.getTimezoneOffset(),
			flags = {
				d: d,
				dd: pad(d),
				ddd: dF.i18n.dayNames[D],
				dddd: dF.i18n.dayNames[D + 7],
				m: m + 1,
				mm: pad(m + 1),
				mmm: dF.i18n.monthNames[m],
				mmmm: dF.i18n.monthNames[m + 12],
				yy: String(y).slice(2),
				yyyy: y,
				h: H % 12 || 12,
				hh: pad(H % 12 || 12),
				H: H,
				HH: pad(H),
				M: M,
				MM: pad(M),
				s: s,
				ss: pad(s),
				l: pad(L, 3),
				L: pad(L > 99 ? Math.round(L / 10) : L),
				t: H < 12 ? "a" : "p",
				tt: H < 12 ? "am" : "pm",
				T: H < 12 ? "A" : "P",
				TT: H < 12 ? "AM" : "PM",
				Z: utc ? "UTC" : (String(date).match(timezone) || [""]).pop().replace(timezoneClip, ""),
				o: (o > 0 ? "-" : "+") + pad(Math.floor(Math.abs(o) / 60) * 100 + Math.abs(o) % 60, 4),
				S: ["th", "st", "nd", "rd"][d % 10 > 3 ? 0 : (d % 100 - d % 10 != 10) * d % 10]
			};

		return mask.replace(token, function($0) {
			return $0 in flags ? flags[$0] : $0.slice(1, $0.length - 1);
		});
	};
}();

// Some common format strings
dateFormat.masks = {
	"default": "ddd mmm dd yyyy HH:MM:ss",
	shortDate: "m/d/yy",
	mediumDate: "mmm d, yyyy",
	longDate: "mmmm d, yyyy",
	fullDate: "dddd, mmmm d, yyyy",
	shortTime: "h:MM TT",
	mediumTime: "h:MM:ss TT",
	longTime: "h:MM:ss TT Z",
	isoDate: "yyyy-mm-dd",
	isoTime: "HH:MM:ss",
	isoDateTime: "yyyy-mm-dd'T'HH:MM:ss",
	isoUtcDateTime: "UTC:yyyy-mm-dd'T'HH:MM:ss'Z'"
};

// Internationalization strings
dateFormat.i18n = {
	dayNames: [
		"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat",
		"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"
	],
	monthNames: [
		"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec",
		"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"
	]
};

// For convenience...
Date.prototype.format = function(mask, utc) {
	return dateFormat(this, mask, utc);
};

/**
 *@description{根据基础设置信息，设置水电气可见性} 
 */
function setWPGVisibility() {


	var hasWater = true,
		hasPower = true,
		hasGas = true,
		hasNetwork = true,
		hasTV = true,
		hasManagement = true,
		hasGarbage = true,
		hasElevator = true,
		hasOthers = true;

	if (settings.HasWater == false) {
		var items = document.querySelectorAll(".water");
		for (var i = 0; i < items.length; i++) {
			items[i].style.display = 'none'
		}
		hasWater = false;
	}
	if (settings.HasPower == false) {
		var items = document.querySelectorAll(".power");
		for (var i = 0; i < items.length; i++) {
			items[i].style.display = 'none'
		}
		hasPower = false;
	}
	if (settings.HasGas == false) {
		var items = document.querySelectorAll(".gas");
		for (var i = 0; i < items.length; i++) {
			items[i].style.display = 'none'
		}
		hasGas = false;
	}

	if (!hasWater && !hasPower && !hasGas) {
		var items = document.querySelectorAll(".wpg");
		for (var i = 0; i < items.length; i++) {
			items[i].style.display = 'none'
		}
	}

	if (settings.HasNetwork == false) {
		var items = document.querySelectorAll(".network");
		for (var i = 0; i < items.length; i++) {
			items[i].style.display = 'none'
		}
		hasNetwork = false;
	}
	if (settings.HasTV == false) {
		var items = document.querySelectorAll(".tv");
		for (var i = 0; i < items.length; i++) {
			items[i].style.display = 'none'
		}
		hasTV = false;
	}
	if (settings.HasManagement == false) {
		var items = document.querySelectorAll(".management");
		for (var i = 0; i < items.length; i++) {
			items[i].style.display = 'none'
		}
		hasManagement = false;
	}
	if (settings.HasGarbage == false) {
		var items = document.querySelectorAll(".garbage");
		for (var i = 0; i < items.length; i++) {
			items[i].style.display = 'none'
		}
		hasGarbage = false;
	}
	if (settings.HasElevator == false) {
		var items = document.querySelectorAll(".elevator");
		for (var i = 0; i < items.length; i++) {
			items[i].style.display = 'none'
		}
		hasElevator = false;
	}
	if (settings.HasOthers == false) {
		var items = document.querySelectorAll(".others");
		for (var i = 0; i < items.length; i++) {
			items[i].style.display = 'none'
		}
		hasOthers = false;
	}

	if (!hasNetwork && !hasTV && !hasManagement && !hasGarbage && !hasElevator && !hasOthers) {
		var items = document.querySelectorAll(".fixed");
		for (var i = 0; i < items.length; i++) {
			items[i].style.display = 'none'
		}
	}
}

function setItemsVisibility(className, display) {

	var items = document.querySelectorAll(className);

	for (var i = 0; i < items.length; i++) {
		items[i].style.display = display;
	}
}

/*
 * @description 设置输入框可写
 */
function setItemEnable(item) {
	if (item) {
		item.removeAttribute('readonly');
		item.removeAttribute('disabled');
		item.style.color = '#000000';
		item.style.borderBottomColor = '#c8c7cc';
	}
}

/**
 * @description {设置输入框不可用}
 */
function setItemDisable(item) {
	item.readOnly = 'readOnly';
	item.disabled = 'disabled';
	item.style.color = '#999999';
	item.style.borderBottomColor = '#F8F9FB';
}

function setItemsReadOnly(selector) {

	var items = document.querySelectorAll(selector);

	for (var i = 0; i < items.length; i++) {

		if (items[i].getAttribute('alwaysEnabled')) {

			console.log(elements[i].getAttribute('alwaysEnabled'));
			continue;
		}
		if (items[i].tagName.toUpperCase() == 'SELECT') {
			items[i].disabled = 'disabled';
		} else {
			items[i].readOnly = 'readOnly';
		}
		items[i].style.color = '#999999';
		items[i].style.borderBottomColor = '#F8F9FB';
	}
}


function setFormReadOnly(form) {

	var elements = form;
	for (var i = 0; i < elements.length; i++) {

		if (elements[i].getAttribute('alwaysEnabled')) {

			console.log(elements[i].getAttribute('alwaysEnabled'));
			continue;
		}
		elements[i].readOnly = 'readOnly';
		elements[i].disabled = 'disabled';
		elements[i].style.color = '#999999';
		elements[i].style.borderBottomColor = '#F8F9FB';
	}
}

//调置水电气缓存
function setCache(key, value) {

	localStorage.setItem(key, value);
}

/**
 * @description {获取缓存，为null或undefine时返回空字符串}
 */
function getCache(key) {

	var value = localStorage.getItem(key);
	if (value != null && value != undefined)
		return value;
	else
		return '';
}

/**
 * @description {清除缓存}
 */
function clearCache(key) {
	localStorage.removeItem(key);
}

/**
 * @description {缓存JSON数据}
 */
function setJSONCache(key, data) {

	setCache(key, JSON.stringify(data));
}

/**
 * @description {获取JSON缓存}
 */
function getJSONCache(key) {

	if (getCache(key))
		return JSON.parse(getCache(key));
	else
		return null;
}

/**
 * @description {获取当前登录用户信息}
 */
function getUser() {
	return getJSONCache(user_model);
}

/**
 * @description {设置用户本地缓存}
 */
function setUser(user) {
	setJSONCache(user_model, user);
}

/**
 * @description {获取当前登录用户信息}
 */
function getSettings() {
	return getJSONCache(settings_model);
}

/**
 * @description {设置配置信息本地缓存} 
 */
function setSettings(settings) {
	setJSONCache(settings_model, settings);
}
/**
 * @description {判断当前用户是否有taskCode权限} 
 * @param{String} 权限常量代码
 */
function hasTask(taskCode) {
	var user = getUser();
	var has = false;
	if (user)
		has = user.TaskCodes.indexOf(taskCode) > -1;
	//console.log('user.HasTask(' + taskCode + ')=' + has);
	return has;
}


function addRoom() {
	var extras = {
		roomid: -1
	};
	openWindow('room', 'room.html', null, extras);
}

function validateTask() {

	var elements = document.querySelectorAll('*[taskCode]');
	var length = elements.length;

	for (var i = 0; i < length; i++) {
		var code = elements[i].getAttribute('taskCode');
		if (!hasTask(code))
			elements[i].style.display = 'none';
	}
}
/**
 *@description{提示框}
 */
function wAlert(message) {
	plus.ui.alert(message, null, msgBoxTitle, buttonCapture);
}
/**
 *@description{获取时间戳，格式yyyy-m-d HH:MM:ss}
 *@param{JSON} 为null或不填时，取当前时间
 */
function getTimestamp(data) {
	var now = dateFormat(new Date(), 'yyyy-m-d HH:MM:ss');
	var timestamp = (data == null) ? now : data.TimeUpdated;
	return timestamp;
}

/*
 * @description: 用于发送请求时，获取时间动态参数
 */
function getTime() {
	return new Date().getTime();
}

/*
 * @description: mui.openWindow方式打开页面
 * @param{id:页面id}
 * @param{url:页面URL}
 * @param{event:需要触发的事件}
 */
function openWindow(id, url, event, extras) {
	var profiles = plus.webview.getWebviewById(id);
	if (profiles) {
		if (event)
			profiles.evalJS(event);
		profiles.show(animation, durations);
	} else {
		mui.openWindow({
			id: id,
			url: url,
			extras: extras,
			show: {
				autoShow: true,
				aniShow: animation,
				duration: durations
			},
			waiting: {
				autoShow: false
			}
		});
	}
}

/**
 * @description {ios下日期输入框 unit会显示不全,改用unit-ios-date}
 */
function setDateCssHack(element) {

	if (mui.os.ios) {
		element.className = 'unit-ios-date';
	}
}

/**
 * @description {将日期字符串转日期}
 */
function parseDate(dateString) {
	var str = dateString.replace(/-/g, "/");
	return new Date(str);
}

/*非框架内代码 END*/