/*!
 * =====================================================
 * 第三方帐号登录相关js
 * =====================================================
 */

var auths = null;
// 监听plusready事件  
document.addEventListener("plusready", function() {
	// 扩展API加载完毕，现在可以正常调用扩展API
	plus.oauth.getServices(function(services) {
		auths = services;
	}, function(e) {
		wAlert("获取认证服务列表失败：" + e.message + " - " + e.code);
	});
}, false);
// 登录操作
function authLogin(idx) {
	var s = auths[idx];
	var openid = null;
	var token = null;
	plus.nativeUI.showWaiting();
	if (!s.authResult) {

		s.login(function(e) {
			// 获取登录操作结果
			var result = e.target.authResult;
			if (result == undefined) {
				mui.toast('第三方认证失败');
				plus.nativeUI.closeWaiting();
			} else {
				if (s.id.indexOf('weixin') > -1) {
					openid = result.openid;
					token = result.access_token;
				} else if (s.id.indexOf('qq') > -1) {
					openid = result.openid;
					token = result.access_token;
				} else if (s.id.indexOf('weibo') > -1) {
					openid = result.uid;
					token = result.token;
				}
				localStorage.setItem(s.id+'_openid', openid);
				localStorage.setItem(s.id+'_token', token);
				connect(s.id, openid,token);
			}
		}, function(e) {
			plus.nativeUI.closeWaiting();
			mui.toast(e.message);
		}, {});
	} else {

		var openid = localStorage.getItem(s.id+'_openid');
		var token = localStorage.getItem(s.id+'_token');
		
		if (openid != undefined && openid != '' && openid != null) {
			connect(s.id, openid,token);
		} else {
			plus.nativeUI.closeWaiting();
			mui.toast('认证信息有误。');
		}
	}
}

var qq = document.getElementById('qq');
var weibo = document.getElementById('weibo');
var weixin = document.getElementById('weixin');

//第三方登录连接
function connect(openType, openId,token) {
	var dt = new Date().getTime();
	var url = 'http://' + server + '/API/Connect.ashx?type=' + openType + '&dt=' + dt;
	mui.ajax(url, {
		data: {
			openId: openId,
			token: token,
			nickName: '',
			figureUrl: ''
		},
		dataType: 'json',
		type: 'get', //HTTP请求类型
		timeout: timeout, //超时时间设置为10秒；
		success: function(data) {
			plus.nativeUI.closeWaiting();
			succes(data);
		},
		error: function(xhr, type, errorThrown) {
			//异常处理；
			mui.toast('网络不给力啊');
			plus.nativeUI.closeWaiting();
		}
	});
}

mui.plusReady(function() {
	isInstalled();
})

function isInstalled() {

	if (mui.os.ios) {

		qq.style.display = 'none';
		weibo.style.display = 'none';
		weixin.style.display = 'none';

		//是否安装QQ
		var TencentOAuth = plus.ios.import("TencentOAuth");
		var isQQInstalled = TencentOAuth.iphoneQQInstalled();
		if (isQQInstalled == "1")
			qq.style.display = '';
		else
			qq.style.display = 'none';
		//是否安装微信
		var WXApi = plus.ios.import("WXApi");
		var isWXInstalled = WXApi.isWXAppInstalled();
		if (isWXInstalled == "1")
			weixin.style.display = '';
		else
			weixin.style.display = 'none';
		//是否安装微博
		var WeiboSDK = plus.ios.import("WeiboSDK");
		var isWBInstalled = WeiboSDK.isWeiboAppInstalled();
		if (isWBInstalled == "1")
			weibo.style.display = '';
		else
			weibo.style.display = 'none';
	} else {

		qq.style.display = '';
		weibo.style.display = '';
		weixin.style.display = '';
	}
}

var huawei = navigator.userAgent.toLowerCase().indexOf('huawei') > -1 || navigator.userAgent.toLowerCase().indexOf('honor') > -1;
weixin.addEventListener('tap', function() {
	bindWeixin();
});
qq.addEventListener('tap', function() {
	bindQQ();
});
weibo.addEventListener('tap', function() {
	bindWeibo();
});

function bindWeixin() {
	if (mui.os.ios) {
		authLogin(1)
	} else {
		authLogin(0);
	}
}

function bindQQ() {
	if (mui.os.ios)
		authLogin(0);
	else
		authLogin(1);
}

function bindWeibo() {
	authLogin(2)
}