/**
 *@description {详情页公用类}
 */
var wEdit = {
	id: -1,
	data: null,
	type: '',
	loadCache: false,
	url: 'xxxxhandler.ashx url',
	task: 'XXX_Update',
	cacheKey: 'cache_',
	init: function(config) {

		wEdit.type = config.type;
		wEdit.url = config.url || ('http://' + server + '/Handler/' + wEdit.type + 'Handler.ashx');
		wEdit.task = config.task;
		wEdit.id = getCache(wEdit.type + '_id');
		wEdit.data = getJSONCache(wEdit.type + '_' + wEdit.id);
		wEdit.cacheKey = 'cache_' + wEdit.type + '_' + wEdit.id;

		//判断页面是否自定义mui.ready事件,默认不自定义
		if (!config.customReady) {
			mui.ready(function() {
				wEdit.loadDatas();
				wEdit.loadLocalCache();
			})
		}
		document.getElementById("save").addEventListener('tap', function() {
			wEdit.save();
		});

		mui('form').on('change', 'input,textarea,select', function() {
			wEdit.setLocalCache();
		})
		mui('form').on('input', 'input,textarea', function() {
			wEdit.setLocalCache();
		})
	},
	loadDatas: function() {

		if (wEdit.data) {
			setFormValue(document.getElementById('form'), wEdit.data);
			if (!hasTask(wEdit.task)) {
				setFormReadOnly(document.getElementById('form'));
				setItemsVisibility('#save', 'none');
			}
			wEdit.clear();
		}
	},
	/**
	 * @description {清除服务器数据缓存}
	 */
	clear: function() {
		clearCache(wEdit.type + '_id');
	},
	save: function() {
		if (validateInput(document.getElementById('form'))) {
			plus.nativeUI.showWaiting('正在保存...');
			//checkbox值为false将不会通过表单传值

			var url = wEdit.url + '?action=save&timestamp=' + getTimestamp(wEdit.data);
			var data = serialize(document.getElementById('form'));

			mui.ajax(url, {
				data: data,
				timeout: timeout,
				dataType: 'json',
				type: 'get',
				success: function(result) {
					plus.nativeUI.closeWaiting();
					wEdit.clearLocalCache();
					wEdit.success(result);
				},
				error: function(xhr, type, errorThrown) {
					//异常处理；
					mui.toast('哎哟，网络不给力呀');
					plus.nativeUI.closeWaiting();
				}
			})
		}
	},
	/**
	 * @description {提交保存返回结果后，调用方法}
	 */
	success: function(result) {
		if (result.IsSucced) {
			//刷新列表
			wEdit.refreshList();
			mui.toast('保存成功');
			plus.webview.currentWebview().close();
		} else {
			wAlert(result.Message);
		}
	},
	/**
	 * @description {刷新列表数据}
	 */
	refreshList: function() {

		//获得列表界面的webview
		//var list = plus.webview.getWebviewById('default-sub');
		var list = plus.webview.currentWebview().opener();
		//触发列表界面的自定义事件（refresh）,从而进行数据刷新
		mui.fire(list, 'refreshList');
		//返回true，继续页面关闭逻辑
		return true;
	},
	/**
	 * @description {判断当前操作是不是新增}
	 */
	isNew: function() {
		return wEdit.id <= 0;
	},
	/**
	 * @description {本地缓存当前表单}
	 */
	setLocalCache: function() {
		var data = jsonlizeForm(document.getElementById('form'), wEdit.data);
		data.TimeUpdated = dateFormat(new Date(), 'yyyy-m-d HH:MM:ss');
		setJSONCache(wEdit.cacheKey, data);
	},
	/**
	 * @description {获取表单本地缓存}
	 */
	getLocalCache: function() {
		return getJSONCache(wEdit.cacheKey);
	},
	/**
	 * @description {清除表单本地缓存}
	 */
	clearLocalCache: function() {
		clearCache(wEdit.cacheKey);
	},
	/**
	 * @description {清除表单本地缓存}
	 */
	loadLocalCache: function() {

		var local = wEdit.getLocalCache();
		var server = wEdit.data;
		var needAsk = local && (!server || parseDate(local.TimeUpdated) > parseDate(server.TimeUpdated));

		if (needAsk) {
			mui.confirm('检测到 ' + local.TimeUpdated + ' 有未保存的数据，是否查看？', msgBoxTitle, ['查看', '丢弃'], function(e) {

				if (e.index == 0) {
					wEdit.data = local;
					wEdit.loadCache = true;
					wEdit.loadDatas();
					//wEdit.clearLocalCache();
				} else if (e.index == 1) {
					wEdit.clearLocalCache();
				}
			})
		}
	},

}