/**
 *@description 批量操作
 * */
var wSelect = {

	showCheckBoxs: false,
	type: 'Room',
	init: function(config) {

		wSelect.type = config.type;
		var url = 'http://' + server + '/Handler/' + wSelect.type + 'Handler.ashx';

		/**
		 *长按，打开批量操作
		 */
		mui('.mui-content').on('longtap', 'li', function(e) {
			wSelect.enableChecked();
			this.querySelector('input[type=checkbox]').checked = true;
		});

		var btnChecked = document.getElementById("btnChecked");
		if (btnChecked) {

			btnChecked.addEventListener('tap', function() {

				//var rows = document.querySelectorAll('#pullrefresh .mui-table-view-cell');
				//var len = rows.length;
				//var chkAll = document.getElementById("chkAll");
				//if (chkAll) chkAll.checked = true;

/*				for (var i = 0; i < len; i++) {
					rows[i].querySelector('input[type=checkbox]').checked = true;
				}*/

				wSelect.enableChecked()
			})
		}

		/**
		 * 全选
		 */
		var chkAll = document.getElementById("chkAll");
		if (chkAll) {
			chkAll.addEventListener('tap', function() {

				var checkBoxs = document.querySelectorAll('#pullrefresh input[type=checkbox]');
				var len = checkBoxs.length;
				var checked = document.getElementById("chkAll").checked;
				for (var i = 0; i < len; i++) {
					checkBoxs[i].checked = !checked;
				}
			})
		}
		/**
		 * 取消批量操作
		 */
		var operCancel = document.getElementById("operCancel");
		if (operCancel) {
			operCancel.addEventListener('tap', function() {
				wSelect.disableChecked();
			})
		}
		/**
		 * 批量删除
		 */
		var operDelete = document.getElementById("operDelete");
		if (operDelete) {
			operDelete.addEventListener('tap', function() {

				if (wSelect.type == null) {
					wAlert('引用页面未指定数据类型');
					return;
				}

				var checkBoxs = document.querySelectorAll('#pullrefresh input[type=checkbox]');
				var len = checkBoxs.length;
				var count = 0;
				var selected = '';

				for (var i = 0; i < len; i++) {
					if (checkBoxs[i].checked) {
						count++;
						selected += checkBoxs[i].value + ',';
					}
				}
				if (count == 0) {
					mui.toast('请选择记录');
					return;
				}

				selected = selected.substring(0, selected.length - 1);
				var dt = new Date().getTime();
				mui.confirm('已选中 ' + count + ' 项，确定要删除吗？', msgBoxTitle, confirmButtons, function(e) {

					if (e.index == 0) {
						execute(url + '?action=deletes&dt=' + dt, selected);
					}
				})
			})
		}
		/**
		 * 批量收租
		 */
		var operReceive = document.getElementById("operReceive");
		if (operReceive) {
			operReceive.addEventListener('tap', function() {
				if (wSelect.type == null) {
					wAlert('引用页面未指定数据类型');
					return;
				}

				var checkBoxs = document.querySelectorAll('#pullrefresh input[type=checkbox]');
				var len = checkBoxs.length;
				var count = 0;
				var selected = '';

				for (var i = 0; i < len; i++) {
					if (checkBoxs[i].checked) {
						count++;
						selected += checkBoxs[i].value + ',';
					}
				}
				if (count == 0) {
					mui.toast('请选择记录');
					return;
				}
				var alertStr = '';
				var urlH = '';
				if (wSelect.type == 'receipt') {
					alertStr = '已选中' + count + ' 项，确定标记为 已收 吗？';
					urlH = 'http://' + server + '/Handler/ReceiptHandler.ashx?action=receipt_paid';
				} else {
					alertStr = '已选中' + count + ' 项，确定生成待收房租吗？';
					urlH = 'http://' + server + '/Handler/ReceiptHandler.ashx?action=room_receipt';
				}
				selected = selected.substring(0, selected.length - 1);
				var dt = new Date().getTime();
				mui.confirm(alertStr, msgBoxTitle, confirmButtons, function(e) {

					if (e.index == 0) {
						execute(urlH + '&dt=' + dt, selected);
					}
				})
			})
		}

		/**
		 * 批量微信催租
		 */
		var operSendWX = document.getElementById("operSendWX");
		if (operSendWX) {
			operSendWX.addEventListener('tap', function() {
				if (wSelect.type == null) {
					wAlert('引用页面未指定listDateType');
					return;
				}

				var checkBoxs = document.querySelectorAll('#pullrefresh input[type=checkbox]');
				var len = checkBoxs.length;
				var count = 0;
				var selected = '';

				for (var i = 0; i < len; i++) {
					if (checkBoxs[i].checked) {
						count++;
						selected += checkBoxs[i].value + ',';
					}
				}
				if (count == 0) {
					mui.toast('请选择记录');
					return;
				}

				selected = selected.substring(0, selected.length - 1);
				var dt = new Date().getTime();
				var url = 'http://' + server + '/API/Weixin.aspx?send=bill&from=app&dt=' + dt;

				mui.confirm('已选中' + count + ' 项，确定通过微信发送房租单吗？', msgBoxTitle,confirmButtons, function(e) {

					if (e.index == 0) {
						execute(url, selected);
					}
				})
			})
		}

		/**
		 * 批量短信催租
		 */
		var operSendSMS = document.getElementById("operSendSMS");
		if (operSendSMS) {
			operSendSMS.addEventListener('tap', function() {
				if (wSelect.type == null) {

					wAlert('引用页面未指定listDateType');
					return;
				}

				var checkBoxs = document.querySelectorAll('#pullrefresh input[type=checkbox]');
				var len = checkBoxs.length;
				var count = 0;
				var selected = '';

				for (var i = 0; i < len; i++) {
					if (checkBoxs[i].checked) {
						count++;
						selected += checkBoxs[i].value + ',';
					}
				}

				if (count == 0) {
					mui.toast('请选择记录');
					return;
				}

				var url = '';
				var alertStr = '';
				var dt = new Date().getTime();
				alertStr = '已选中 ' + count + ' 项，确定发送短信催租吗？';
				url = 'http://' + server + '/Pages/ReceiptEdit.aspx?send=bill&from=app&dt=' + dt;
				selected = selected.substring(0, selected.length - 1);
				mui.confirm(alertStr, msgBoxTitle, confirmButtons, function(e) {

					if (e.index == 0) {
						execute(url, selected);
					}
				})
			})
		}
		/*
		 * 执行批量操作
		 */
		function execute(url, selectedIds) {
			var data = {
				ids: selectedIds
			};
			mui.getJSON(url, data, function(result) {

				if (result.IsSucced) {

					if (wList)
						wList.refresh();
					else
						refresh();
					
					wSelect.disableChecked();
					mui.toast(result.Message);
				} else {
					wAlert(result.Message);
				}
			})
		}
	},
	/**
	 *@description 启用复选框
	 * */
	enableChecked: function() {

		wSelect.showCheckBoxs = true;
		document.getElementById("chkAll").checked = true;
		
		var rows = document.querySelectorAll('#pullrefresh .mui-table-view-cell');
		var len = rows.length;

		setItemsVisibility('#footer', 'none');
		setItemsVisibility('#barOperation', '');
		for (var i = 0; i < len; i++) {
			rows[i].classList.add('mui-checkbox');
			rows[i].classList.add('mui-left');
		}
		setItemsVisibility('.customer', 'block');
		setItemsVisibility('#pullrefresh input[type=checkbox]', 'block');
	},
	/**
	 * @description 关闭复选框
	 * */
	disableChecked: function() {

		wSelect.showCheckBoxs = false;
		//因点击批量，会触发选中
		document.getElementById("chkAll").checked = true;
		
		var rows = document.querySelectorAll('#pullrefresh .mui-table-view-cell');
		var len = rows.length;
		setItemsVisibility('#footer', '');
		setItemsVisibility('#barOperation', 'none');
		for (var i = 0; i < len; i++) {
			rows[i].classList.remove('mui-checkbox');
			rows[i].classList.remove('mui-left');
			rows[i].querySelector('input[type=checkbox]').checked = false;
		}
		
		setItemsVisibility('.customer', 'none');
		setItemsVisibility('#pullrefresh input[type=checkbox]', 'none');
	}

}