/**
 * @description 图片上传类
 **/
var wUploader = {

	uploadServer: 'http://' + server + "/Handler/UploadHandler.ashx?action=base64",
	files: [],
	f1Name: null,
	f1Data: null,
	f2Name: null,
	f2Data: null,

	/**
	 * @description 拍照获取图片
	 **/
	shareCameraPicture: function(pic) {
		wUploader.togglePopover(pic);
		var cmr = plus.camera.getCamera();
		cmr.captureImage(function(p) {		
			//保存到相册
			plus.gallery.save(p);

			plus.io.resolveLocalFileSystemURL(p, function(entry) {
				wUploader.appendFile(pic, entry.toLocalURL());
			}, function(e) {
				//mui.toast(e.message);
			});
		}, function(e) {
			//mui.toast(e.message);
		});
	},

	/**
	 * @description 从相册获取图片
	 **/
	shareGalleryPicture: function(pic) {
		wUploader.togglePopover(pic);
		plus.gallery.pick(function(p) {
			wUploader.appendFile(pic, p);
		},function(e){
			mui.toast(e.message);
		});
	},

	togglePopover: function(pic) {
		var id = pic.getAttribute('id');
		if (id == "Image1")
			mui('#picture1').popover('toggle');
		else
			mui('#picture2').popover('toggle');
	},
	appendFile: function(pic, path) {

		plus.nativeUI.showWaiting('处理中');
		
		pic.src = path;
		var img = new Image();
		img.src = path; // 传过来的图片路径在这里用。
		img.onload = function() {
			EXIF.getData(img, function() {
				var that = this;
				//生成比例 
				var w = that.width,
					h = that.height,
					scale = w / h;
				w = 480 || w; //480  你想压缩到多大，改这里
				h = w / scale;
				//生成canvas
				var canvas = document.createElement('canvas');
				var ctx = canvas.getContext('2d');
				canvas.setAttribute('width', w);
				canvas.setAttribute('height', h);

				ctx.fillStyle = '#fff';
				ctx.fillRect(0, 0, w, h);

				// 兼容iOS6/iOS7
				var ua = detect.parse(navigator.userAgent);
				if (ua.os.family === 'iOS' && parseInt(ua.os.version) < 8) {

					var orientation = EXIF.getTag(img, "Orientation");
					var mpImg = new MegaPixImage(img);
					mpImg.render(canvas, {
						width: canvas.width,
						height: canvas.height,
						orientation: orientation
					});

				} else {
					ctx.drawImage(that, 0, 0, w, h);
				}

				var base64 = canvas.toDataURL('image/jpeg', 1 || 0.5);

				var picID = pic.getAttribute('id');
				var suffix = path.substr(path.lastIndexOf('.'));
				var picName = wUploader.getUid() + suffix;

				document.querySelector("input[name=" + picID + "]").value = picName;
				// 把base64数据丢过去，上传要用。
				if (picID == 'Image1') {
					wUploader.f1Name = picName;
					wUploader.f1Data = base64; //FilName+FileData
				} else if (picID == 'Image2') {
					wUploader.f2Name = picName;
					wUploader.f2Data = base64;
				}

				pic.src = base64; //这里丢到img 的 src 里面就能看到效果了
				pic.setAttribute('src1', base64);
				
				plus.nativeUI.closeWaiting();
				
				wUploader.upload(false);
			})
		}
	},
	/**
	 * @description 上传
	 * */
	upload: function(clickSave) {
		if (clickSave) {
			plus.nativeUI.showWaiting('正在上传...');
		}
		mui.ajax(wUploader.uploadServer, {
			data: {
				Image1: wUploader.f1Name,
				Image1Data: wUploader.f1Data,
				Image2: wUploader.f2Name,
				Image2Data: wUploader.f2Data
			},
			timeout: 30000,
			dataType: 'json',
			type: 'post',
			success: function(result) {
				plus.nativeUI.closeWaiting();
				if (result.IsSucced) {
					//刷新列表
					wEdit.refreshList();
					//mui.toast('保存成功');
					wUploader.f1Data = null;
					wUploader.f1Name = null;
					wUploader.f2Data = null;
					wUploader.f2Name = null;
					if (clickSave) {
						plus.webview.currentWebview().close();
					}
				} else {
					mui.toast('上传失败' + result.Message);
				}
			},
			error: function(xhr, type, errorThrown) {
				//异常处理；
				mui.toast(error_timeout);
				if (clickSave) {
					plus.nativeUI.closeWaiting();
				}
			}
		})
	},
	/**
	 * @description 生成唯一的文件名称
	 * */
	getUid: function() {
		return Math.floor(Math.random() * 100000000 + 10000000).toString();
	},

	imageViewer: null,
	/**
	 * @description 查看大图
	 * */
	showImg: function(pic) {

		wUploader.togglePopover(pic);
		if (wUploader.imageViewer) {
			console.log("重复点击！");
			return;
		}
		var url = "/pages/imageViewer.html";
		wUploader.imageViewer = plus.webview.create(url, url, {
			scrollIndicator: 'none',
			scalable: true,
			bounce: "all"
		});
		wUploader.imageViewer.addEventListener("loaded", function() {
			wUploader.imageViewer.evalJS("loadMedia('" + pic.getAttribute('src1') + "')");

		}, false);
		wUploader.imageViewer.addEventListener("close", function() {
			wUploader.imageViewer = null;
		}, false);
		wUploader.imageViewer.show("pop-in");
	}
}